--includes
	include IniFile.e

	with trace

sequence
	Cmd,
	CmdLin,
	FileSpec,
	Key,
	Section,
	ValidCmds,
	Value

--===========================================================================--
procedure Usage()
	WritelnHi("USAGE:    IniFile.exe [?] FileSpec Read|Write|Delete Section Key [Value]")
	Writeln  (" ?        Show this help screen")
	Writeln  (" FileSpec File specification of the ini file to use")
	Writeln  ("          May be an ENVVAR that holds the filespec")
	Writeln  ("Commands")
	Writeln  (" Read     Read a key and put its value to STDOUT")
	Writeln  ("          If no key is found, NOTFOUND is the result")
	Writeln  (" Write    Write the Key passed with the Value passed")
	Writeln  (" Delete   Delete the Key passed")
	Writeln  ("Arguments")
	Writeln  (" Section  Section having Key")
	Writeln  (" Key      Key to use for all Commands")
	Writeln  (" Value    New Value for Key after Write command")
	Writeln  ("Examples")
	Writeln  (" IniFile.exe Read    YourSec    YourKey")
	Writeln  (" IniFile.exe Write   YourSec    YourKey    NewValue")
	Writeln  (" IniFile.exe Write  \"Your Sec\" \"Your Key\" \"New Value\"")
	Writeln  (" IniFile.exe Delete  YourKey")
	Writeln  ("IniFile.exe version 1.0")
	Writeln  (" IniFile.exe operates on standard Windows ini files.")
	Writeln  (" As shown in in a write example, use double quotes for any argument")
	Write    (" that has a space in it.")

	Beep()
	abort(1)
end procedure --Usage

procedure Initialize()
	ValidCmds = {"READ","WRITE","DELETE"}
	FileSpec = ""
	Cmd = ""
	Section = ""
	Key = ""
	Value = ""

end procedure --

procedure ParseCmdLin()
	CmdLin = command_line()
	if length(CmdLin) > 2 then FileSpec = TrimSpace(CmdLin[3]) end if
	if length(CmdLin) > 3 then Cmd 			= TrimSpace(upper(CmdLin[4])) end if
	if length(CmdLin) > 4 then Section 	= TrimSpace(CmdLin[5]) end if
	if length(CmdLin) > 5 then Key 			= TrimSpace(CmdLin[6]) end if
	if length(CmdLin) > 6 then Value 		= TrimSpace(CmdLin[7]) end if

	if length(FileSpec)=0 then Usage() end if
	if not find(Cmd,ValidCmds) or	find('?',FileSpec) then Usage()	end if
	if find(Cmd,{"DELETE","READ"}) then
		if length(CmdLin)<6 then Usage() end if
		if length(Key)=0 then Usage() end if
	end if
	if find(Cmd,{"WRITE"}) then
		if length(CmdLin)<7 then Usage() end if
		if length(Key)=0 then Usage() end if
	end if
end procedure --ParseCmdLin

--===========================================================================--
--Initialize
	Initialize()
	ParseCmdLin()
	IniFile({FileSpec,Cmd,Section,Key,Value})