--------------------------------------------
----	Extended slicing by Gargoyle	----
----(Anders Eurenius <c96aes@cs.umu.se>)----
--------------------------------------------
	--global function sRev(sequence s)
	--global function sFlat(sequence s)
	--global function sGet(object s,sequence ix)
	--global function sAnd(sequence s)
	--global function sOr(sequence s)
	--global function sLeft(sequence s,integer ix)
	--global function sRight(sequence s,integer ix)
	--global function sSub(sequence s,integer b,integer e)
	--global function Insert(sequence s,integer ix,object x)
	--global function Overlay(sequence s,sequence t,integer ix)
	--global function Delete(sequence s,integer ix)
	--global function sInsert(sequence s,integer ix,object x)
	--global function sDelete(sequence s,integer b,integer e)
	--global function sFind(sequence s, object x)

global function sRev(sequence s)
	sequence t t={}
	for i=length(s) to 1 by -1 do
		t=t&{s[i]}
	end for
	return(t)
end function

global function sFlat(sequence s)
	sequence f
	atom done
	f={} done=0
	while not done do
		done=1
		for i=1 to length(s) do f=f&s[i] if sequence(s[i]) then done=0 end if end for
		s=f f={}
	end while
	return(s)
end function

global function sGet(object s,sequence ix)
	for i=1 to length(ix) do if sequence(s) then s=s[ix[i]] else return({}) end if end for
	return (s)
end function

global function sAnd(sequence s)
	s=sFlat(s)
	for i=1 to length(s) do if not s[i] then return(0) end if end for
	return(1)
end function

global function sOr(sequence s)
	s=sFlat(s)
	for i=1 to length(s) do if s[i] then return(1) end if end for
	return(0)
end function

global function sLeft(sequence s,integer ix)
	integer l l=length(s)
	if	ix>l then ix=l end if
	if	l=0 or ix<1 then return({}) else return(s[1..ix]) end if
end function

global function sRight(sequence s,integer ix)
	integer l l=length(s)
	if	ix<1 then ix=1 end if
	if	l=0 or ix>l then return({}) else return(s[ix..l]) end if
end function

global function sSub(sequence s,integer b,integer e)
	--sSub(seq, begin pos, end pos)
	--return the subsequence
	integer l l=length(s)
	if b>e or b>l or 1>e then return({}) end if
	if b<1 then b=1 end if
	if e>l then e=l end if
	return(s[b..e])
end function

global function Insert(sequence s,integer ix,object x)
	return(sLeft(s,ix)&x&sRight(s,ix+1))
end function

global function Overlay(sequence s,sequence t,integer ix)
	return(sLeft(s,ix-1)&t&sRight(s,ix+length(t)))
end function

global function Delete(sequence s,integer ix)
	return(sLeft(s,ix-1)&sRight(s,ix+1))
end function

global function sInsert(sequence s,integer ix,object x)
	return(sLeft(s,ix)&{x}&sRight(s,ix+1))
end function

global function sDelete(sequence s,integer b,integer e)
	return(sLeft(s,b-1)&sRight(s,e+1))
end function

global function sFind(sequence s, object x)
	sequence t t={}
	for i=1 to length(s) do
		if compare(s[i],x)=0 then t=t&i end if
	end for
	return(t)
end function
