include Rtcgen.e
include Rslice.e
	-------------------------------------------------------------------------
	--String handling routines                Irv Mullins (irv@ellijay.com)
	--------------------------------------------------------------------------
global function String(object x)
	--global function String(OBJ x) returns true if x is a string
	--Irv Mullins
	atom is_string
	if sequence(x) then
 		is_string = 1
 		for i = 1 to length(x) do
   		if sequence(x[i]) then
				is_string = 0
   		else
				--if x[i] < ' ' then
				--RTC Allow for \t \n ... in a string
				if (x[i] < ' ') and not find(x[i],9&10&16&17) then
					is_string = 0
	 			end if
  		end if
 		end for
	else
		is_string = 0
	end if
	return is_string
end function

global function stInsert(sequence work, sequence new, integer loc)
	--global function stInsert(SEQ workstring, SEQ newstring, INT location)
	--Irv Mullins
	integer workend
	if String(work) then
		workend = length(work)
		if loc > workend then
			work = work & new
			return work
		end if
		work = work[1..loc-1] & new & work[loc..workend]
	end if
	return work
end function

global function stDelete(sequence work, integer start, integer len)
	--global function stDelete(SEQ workstring, INT start, INT length)
	--Irv Mullins
	integer workend
	if String(work) then
		workend = length(work)
		if start > workend then
			return work
		end if
		if start > 1 then
			work = work[1..start-1] & work[start+len..workend]
		else
			work = work[start+len..workend]
		end if
	end if
	return work
end function

global function stReplace(sequence work, sequence oldstring, sequence newstring)
	--global function stReplace(SEQ workstring, SEQ oldstring, SEQ newstring)
	--Replace the oldstring with the newstring in workstring (simple,eh?)
	--Irv Mullins
	integer loc
	if String(work) then
		loc = match(oldstring,work)
		if loc > 0 then
			work = stDelete(work,loc,length(oldstring))
			work = stInsert(work,newstring,loc)
		end if
		else for i = 1 to length(work) do
		work[i] = stReplace(work[i],oldstring,newstring)
		end for
	end if
	return work
end function

-------------------------------------------------------------------------------
global function TrimAll(sequence s)
	--TrimAll - returns string stripped of leading and trailing white space/eol
	--Zeitlin
	sequence t
	if length(s)=0 then
		return s
	end if
	t = s
	while (t[1]=' ') or (t[1]='\t') or (t[1]='\n') or (t[1]='\r') do
		t = t[2..length(t)]
		if length(t)=0 then
			return t
		end if
	end while
	while (t[length(t)]=' ') or (t[length(t)]='\t') or
			(t[length(t)]='\n') or (t[length(t)]='\r') do
		t = t[1..length(t)-1]
		if length(t)=0 then
			return t
		end if
	end while
	return t
end function

global function TrimSpace(sequence s)
	--TrimSpace - returns string stripped of leading and trailing white space
	--Zeitlin
	sequence t
	if length(s)=0 then
		return s
	end if
	t = s
	while (t[1]=' ') or (t[1]='\t') do
		t = t[2..length(t)]
		if length(t)=0 then
			return t
		end if
	end while
	while (t[length(t)]=' ') or (t[length(t)]='\t') do
		t = t[1..length(t)-1]
		if length(t)=0 then
			return t
		end if
	end while
	return t
end function

global function Left(sequence s, integer i)
	--left - returns leftmost slice of length i of a string
	--Zeitlin
	OkayGlb = TRUE
	if i > length(s) then
		OkayGlb = FALSE
		return s
	end if
	return s[1..i]
end function

global function Right(sequence s, integer i)
	--right - returns rightmost slice of length i of a string
	--Zeitlin
	OkayGlb = TRUE
	if i > length(s) then
		OkayGlb = FALSE
		return s
	end if
	return s[length(s)-i+1..length(s)]
end function

-------------------------------------------------------------------------------
global function LeftToChar(sequence s,atom x) -->seq
	--Return left end seq up to a char
	--Anders Eurenius strhead
	sequence w w={}
	for i=1 to length(s) do
		if s[i]=x then
			exit
		else w=w&s[i]
		end if
	end for
	return(w)
end function

global function RightToChar(sequence s,atom x) -->seq
	--Return right end of seq back to a char
	--Anders Eurenius strtail
	s=sRev(s)
	return(sRev(s[1..find(x,s)-1]))
end function